(
	local tempDir = (getDir #temp) + "\\InstanceTool\\"
	local tempIconsDir = tempDir + "Icons\\"
	local snowballToolsDir = (getDir #userScripts) + "\\Snowball_Tools\\"
	local scriptDir = snowballToolsDir + "InstanceTool\\"
	local macosDir = getDir #userMacros + "\\"
	local iconsDir = getDir #userIcons + "\\"
	local scriptFile = "InstanceTool.mse"
	local macroFile = "InstanceTool.mcr"
	local iconFiles = for f in (getFiles (tempIconsDir + "*")) collect filenameFromPath f
	
	fn deleteDirTree dir =
	(
		local subDirs = getDirectories (dir + "*")
		for sub in subDirs do
			deleteDirTree sub
		
		local files = getFiles (dir + "*")
		for f in files do
			deleteFile f
		
		deleteFile dir
	)
	
	fn cleanTempFiles =
	(
		deleteDirTree tempDir
	)
	
	fn uninstallOldVersion =
	(
		if doesFileExist scriptDir then
			deleteDirTree scriptDir
		
		for f in iconFiles where doesFileExist (iconsDir + f) do
			deleteFile (iconsDir + f)
	)
	
	fn installTool =
	(
		if not doesFileExist snowballToolsDir then
			makeDir snowballToolsDir
		
		makeDir scriptDir
		
		copyFile (tempDir + scriptFile) (scriptDir + scriptFile)
		
		for f in iconFiles do 
			copyFile (tempIconsDir + f) (iconsDir + f)
		
		fileIn (tempDir + macroFile)
		colorman.reInitIcons()
		macros.run "Snowball VFX" "InstanceTool"
	)
	
	uninstallOldVersion()
	installTool()
	cleanTempFiles()
)